<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.orionorigin.com/
 * @since             1.0.0
 * @package           Vpc_Gillepsie
 *
 * @wordpress-plugin
 * Plugin Name:       VPC Initials add-on
 * Plugin URI:        https://www.orionorigin.com/
 * Description:       This is a short description of what the plugin does. It's displayed in the WordPress admin area.
 * Version:           1.0.0
 * Author:            orion
 * Author URI:        https://www.orionorigin.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       vpc-gillepsie
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-vpc-gillepsie-activator.php
 */
function activate_vpc_gillepsie() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-gillepsie-activator.php';
	Vpc_Gillepsie_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-vpc-gillepsie-deactivator.php
 */
function deactivate_vpc_gillepsie() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-gillepsie-deactivator.php';
	Vpc_Gillepsie_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_vpc_gillepsie' );
register_deactivation_hook( __FILE__, 'deactivate_vpc_gillepsie' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-vpc-gillepsie.php';
require plugin_dir_path( __FILE__ ) . 'skins/class-vpc-gillepsie-skin.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_vpc_gillepsie() {
	$plugin = new Vpc_Gillepsie();
	$plugin->run();

}
run_vpc_gillepsie();
